/* main.h - include file for main.c
   Copyright (C) 2000 Rik Snel <snel@phys.uu.nl>
   Parts copyright by Eric S. Raymond and the Free Software Foundation

   This file is part of newsleech.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. 
*/

extern const char *exec_name;
extern FILE *yyin;

/* These represent index numbers and structures in the structure with structures
   with structures defined down. They will be used to fill the structures when
   parsing the commandline. (the extra T means sTructure) (and to keep the 
   source readable) Optional exercise: expand ARTICLES by hand.
*/
#define SERVERS		rootnode.count
#define SERVERT		rootnode.servers[SERVERS-1]
#define GROUPS		SERVERT.count
#define GROUPT		SERVERT.groups[GROUPS-1]
#define POSTINGS	GROUPT.count
#define POSTINGT	GROUPT.postings[POSTINGS-1]
#define ARTICLES	POSTINGT.count

void print_usage(void);

void print_help(void);

int fill_posting(struct postinginfo *posting, char *optarg);

int fill_group(char *command, struct groupinfo *group, char *filename, char *header, char action, char *pipeto);

int fill_server(struct serverinfo *server, char *optarg);

int fill_rootnode(struct rootnodeinfo *rootnode, char *optarg);
	 
int ch_port(int port, struct rootnodeinfo *rootnode);

int ch_user(char *user, struct rootnodeinfo *rootnode);

int ch_pass(char *pass, struct rootnodeinfo *rootnode);

void verbose_kd(char *keyword, int decimal);

void verbose_ka(char *keyword, char *argument);

void verbose_k(char *keyword);

int whitespace(char *string);

void parsescript(char *name);

void option_verbose(char *optarg, int optind);

void option_port(char *optarg);

void option_interval(char *optarg);

void option_aretry(char *optarg);

void option_username(char *optarg);

void option_password(char *optarg);

void option_filename(char *optarg);

void option_bea(char *scriptcmd, char *tmpcmd);

void option_list(char *optarg);

void option_stdout(void);

void option_range(char *optarg);

void option_script(char *optarg);

int incredibly_large_and_ugly_switch_statement(int option, char *optarg);

int yylex(int *linenum, int *option, char* *optarg);

